JUCE: AudioParameterInt Class Reference

JUCE

Public Member Functions | Protected Member Functions | List of all members
AudioParameterInt Class Reference
juce_audio_processors » utilities

Provides a class of AudioProcessorParameter that can be used as an integer value with a given range. More...

`#include <juce_AudioParameterInt.h>`

Inheritance diagram for AudioParameterInt:

## Public Member Functions
| AudioParameterInt (const ParameterID &parameterID, const String &parameterName, int minValue, int maxValue, int defaultValue, const AudioParameterIntAttributes &attributes={})
| Creates a AudioParameterInt with the specified parameters. More...
| AudioParameterInt (const ParameterID &parameterID, const String &parameterName, int minValue, int maxValue, int defaultValueIn, const String &parameterLabel, std::function< String(int value, int maximumStringLength)> stringFromInt=nullptr, std::function< int(const String &text)> intFromString=nullptr)
| Creates a AudioParameterInt with the specified parameters. More...
| ~AudioParameterInt () override
| Destructor. More...
int | get () const noexcept
| Returns the parameter's current value as an integer. More...
| operator int () const noexcept
| Returns the parameter's current value as an integer. More...
AudioParameterInt & | operator= (int newValue)
| Changes the parameter's current value to a new integer. More...
Range< int > | getRange () const noexcept
| Returns the parameter's range. More...
const NormalisableRange< float > & | getNormalisableRange () const override
| Returns the range of values that the parameter can take. More...
Public Member Functions inherited from RangedAudioParameter
int | getNumSteps () const override
| Returns the number of steps for this parameter based on the normalisable range's interval. More...
float | convertTo0to1 (float v) const noexcept
| Normalises and snaps a value based on the normalisable range. More...
float | convertFrom0to1 (float v) const noexcept
| Denormalises and snaps a value based on the normalisable range. More...
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
Public Member Functions inherited from AudioProcessorParameterWithID
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const AudioProcessorParameterWithIDAttributes &attributes={})
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
| AudioProcessorParameterWithID (const ParameterID &parameterID, const String &parameterName, const String &parameterLabel, Category parameterCategory=AudioProcessorParameter::genericParameter)
| The creation of this object requires providing a name and ID which will be constant for its lifetime. More...
String | getName (int) const override
| Returns the name to display for this parameter, which should be made to fit within the given string length. More...
String | getLabel () const override
| Some parameters may be able to return a label string for their units. More...
Category | getCategory () const override
| Returns the parameter's category. More...
String | getParameterID () const override
| Returns an ID that is unique to this parameter. More...
bool | isMetaParameter () const override
| Should return true if this parameter is a "meta" parameter. More...
bool | isAutomatable () const override
| Returns true if the host can automate this parameter. More...
bool | isOrientationInverted () const override
| This can be overridden to tell the host that this parameter operates in the reverse direction. More...
Public Member Functions inherited from HostedAudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled. More...
Public Member Functions inherited from AudioProcessorParameter
| AudioProcessorParameter () noexcept=default
| AudioProcessorParameter (int versionHint)
| The version hint supplied to this constructor is used in Audio Unit plugins to aid ordering parameter identifiers when JUCE_FORCE_USE_LEGACY_PARAM_IDS is not enabled. More...
virtual | ~AudioProcessorParameter ()
| Destructor. More...
void | setValueNotifyingHost (float newValue)
| A processor should call this when it needs to change one of its parameters. More...
void | beginChangeGesture ()
| Sends a signal to the host to tell it that the user is about to start changing this parameter. More...
void | endChangeGesture ()
| Tells the host that the user has finished changing this parameter. More...
virtual bool | isDiscrete () const
| Returns whether the parameter uses discrete values, based on the result of getNumSteps, or allows the host to select values continuously. More...
virtual bool | isBoolean () const
| Returns whether the parameter represents a boolean switch, typically with "On" and "Off" states. More...
int | getParameterIndex () const noexcept
| Returns the index of this parameter in its parent processor's parameter list. More...
virtual String | getCurrentValueAsText () const
| Returns the current value of the parameter as a String. More...
virtual StringArray | getAllValueStrings () const
| Returns the set of strings which represent the possible states a parameter can be in. More...
int | getVersionHint () const
void | addListener (Listener *newListener)
| Registers a listener to receive events when the parameter's state changes. More...
void | removeListener (Listener *listener)
| Removes a previously registered parameter listener. More...
void | sendValueChangedMessageToListeners (float newValue)

## Protected Member Functions
virtual void | valueChanged (int newValue)
| Override this method if you are interested in receiving callbacks when the parameter value changes. More...

## Additional Inherited Members
Public Types inherited from AudioProcessorParameter
enum | Category { genericParameter = (0 << 16) | 0 , inputGain = (1 << 16) | 0 , outputGain = (1 << 16) | 1 , inputMeter = (2 << 16) | 0 , outputMeter = (2 << 16) | 1 , compressorLimiterGainReductionMeter = (2 << 16) | 2 , expanderGateGainReductionMeter = (2 << 16) | 3 , analysisMeter = (2 << 16) | 4 , otherMeter = (2 << 16) | 5 }
Public Attributes inherited from AudioProcessorParameterWithID
const String | paramID
| Provides access to the parameter's ID string. More...
const String | name
| Provides access to the parameter's name. More...
const String | label
| Provides access to the parameter's label. More...
const Category | category
| Provides access to the parameter's category. More...

## Detailed Description

Provides a class of AudioProcessorParameter that can be used as an integer value with a given range.

See also
  AudioParameterFloat, AudioParameterBool, AudioParameterChoice

## Constructor & Destructor Documentation

## ◆ AudioParameterInt() [1/2]

AudioParameterInt::AudioParameterInt | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | int | minValue,
|  | int | maxValue,
|  | int | defaultValue,
|  | const AudioParameterIntAttributes & | attributes = `{}`
| ) |  |

Creates a AudioParameterInt with the specified parameters.

Note that the attributes argument is optional and only needs to be supplied if you want to change options from their default values.

Example usage:

auto attributes = AudioParameterIntAttributes().withStringFromValueFunction ([] (auto x, auto) { return String (x); })
.withLabel ("things");
auto param = std::make_unique<AudioParameterInt> ("paramID", "Parameter Name", 0, 100, 50, attributes);
AudioParameterIntAttributes
Properties of an AudioParameterInt.
Definition: juce_AudioParameterInt.h:34
RangedAudioParameterAttributes::withStringFromValueFunction
JUCE_NODISCARD auto withStringFromValueFunction(StringFromValue x) const
An optional lambda function that converts a non-normalised value to a string with a maximum length.
Definition: juce_RangedAudioParameter.h:53
String
The JUCE String class!
Definition: juce_String.h:54
gl::x
GLdouble x
Definition: juce_gl.h:940
gl::param
GLenum GLfloat param
Definition: juce_gl.h:647

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  minValue | The minimum parameter value
  maxValue | The maximum parameter value
  defaultValue | The default value
  attributes | Optional characteristics

## ◆ AudioParameterInt() [2/2]

AudioParameterInt::AudioParameterInt | ( | const ParameterID & | parameterID,
|  | const String & | parameterName,
|  | int | minValue,
|  | int | maxValue,
|  | int | defaultValueIn,
|  | const String & | parameterLabel,
|  | std::function< String(int value, int maximumStringLength)> | stringFromInt = `nullptr`,
|  | std::function< int(const String &text)> | intFromString = `nullptr`
| ) |  |

Creates a AudioParameterInt with the specified parameters.

Parameters

  parameterID | The parameter ID to use
  parameterName | The parameter name to use
  minValue | The minimum parameter value
  maxValue | The maximum parameter value
  defaultValueIn | The default value
  parameterLabel | An optional label for the parameter's value
  stringFromInt | An optional lambda function that converts a int value to a string with a maximum length. This may be used by hosts to display the parameter's value.
  intFromString | An optional lambda function that parses a string and converts it into an int. Some hosts use this to allow users to type in parameter values.

## ◆ ~AudioParameterInt()

AudioParameterInt::~AudioParameterInt | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ get()

int AudioParameterInt::get | ( |  | ) | const
| noexcept

Returns the parameter's current value as an integer.

References roundToInt(), and gl::value.

## ◆ operator int()

AudioParameterInt::operator int | ( |  | ) | const
| noexcept

Returns the parameter's current value as an integer.

References dsp::get().

## ◆ operator=()

AudioParameterInt & AudioParameterInt::operator= | ( | int | newValue | ) |

Changes the parameter's current value to a new integer.

The value passed in will be snapped to the permitted range before being used.

## ◆ getRange()

Range< int > AudioParameterInt::getRange | ( |  | ) | const
| noexcept

Returns the parameter's range.

References RangedAudioParameter::getNormalisableRange(), and int().

## ◆ getNormalisableRange()

const NormalisableRange< float > & AudioParameterInt::getNormalisableRange | ( |  | ) | const
| overridevirtual

Returns the range of values that the parameter can take.

Implements RangedAudioParameter.

References gl::range.

## ◆ valueChanged()

virtual void AudioParameterInt::valueChanged | ( | int | newValue | ) |
| protectedvirtual

Override this method if you are interested in receiving callbacks when the parameter value changes.

The documentation for this class was generated from the following file:

- juce_AudioParameterInt.h